package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsDiscountExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsDiscountExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDiscountNoIsNull() {
            addCriterion("discount_no is null");
            return (Criteria) this;
        }

        public Criteria andDiscountNoIsNotNull() {
            addCriterion("discount_no is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountNoEqualTo(String value) {
            addCriterion("discount_no =", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoNotEqualTo(String value) {
            addCriterion("discount_no <>", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoGreaterThan(String value) {
            addCriterion("discount_no >", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoGreaterThanOrEqualTo(String value) {
            addCriterion("discount_no >=", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoLessThan(String value) {
            addCriterion("discount_no <", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoLessThanOrEqualTo(String value) {
            addCriterion("discount_no <=", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoLike(String value) {
            addCriterion("discount_no like", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoNotLike(String value) {
            addCriterion("discount_no not like", value, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoIn(List<String> values) {
            addCriterion("discount_no in", values, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoNotIn(List<String> values) {
            addCriterion("discount_no not in", values, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoBetween(String value1, String value2) {
            addCriterion("discount_no between", value1, value2, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNoNotBetween(String value1, String value2) {
            addCriterion("discount_no not between", value1, value2, "discountNo");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIsNull() {
            addCriterion("discount_name is null");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIsNotNull() {
            addCriterion("discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountNameEqualTo(String value) {
            addCriterion("discount_name =", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotEqualTo(String value) {
            addCriterion("discount_name <>", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameGreaterThan(String value) {
            addCriterion("discount_name >", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("discount_name >=", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLessThan(String value) {
            addCriterion("discount_name <", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("discount_name <=", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLike(String value) {
            addCriterion("discount_name like", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotLike(String value) {
            addCriterion("discount_name not like", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIn(List<String> values) {
            addCriterion("discount_name in", values, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotIn(List<String> values) {
            addCriterion("discount_name not in", values, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameBetween(String value1, String value2) {
            addCriterion("discount_name between", value1, value2, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotBetween(String value1, String value2) {
            addCriterion("discount_name not between", value1, value2, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIsNull() {
            addCriterion("discount_type is null");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIsNotNull() {
            addCriterion("discount_type is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeEqualTo(Integer value) {
            addCriterion("discount_type =", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotEqualTo(Integer value) {
            addCriterion("discount_type <>", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeGreaterThan(Integer value) {
            addCriterion("discount_type >", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("discount_type >=", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeLessThan(Integer value) {
            addCriterion("discount_type <", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeLessThanOrEqualTo(Integer value) {
            addCriterion("discount_type <=", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIn(List<Integer> values) {
            addCriterion("discount_type in", values, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotIn(List<Integer> values) {
            addCriterion("discount_type not in", values, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeBetween(Integer value1, Integer value2) {
            addCriterion("discount_type between", value1, value2, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("discount_type not between", value1, value2, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIsNull() {
            addCriterion("discount_condition is null");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIsNotNull() {
            addCriterion("discount_condition is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionEqualTo(BigDecimal value) {
            addCriterion("discount_condition =", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotEqualTo(BigDecimal value) {
            addCriterion("discount_condition <>", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionGreaterThan(BigDecimal value) {
            addCriterion("discount_condition >", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_condition >=", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionLessThan(BigDecimal value) {
            addCriterion("discount_condition <", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_condition <=", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIn(List<BigDecimal> values) {
            addCriterion("discount_condition in", values, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotIn(List<BigDecimal> values) {
            addCriterion("discount_condition not in", values, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_condition between", value1, value2, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_condition not between", value1, value2, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIsNull() {
            addCriterion("discount_price is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIsNotNull() {
            addCriterion("discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("discount_price =", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("discount_price <>", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("discount_price >", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_price >=", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceLessThan(BigDecimal value) {
            addCriterion("discount_price <", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_price <=", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("discount_price in", values, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("discount_price not in", values, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_price between", value1, value2, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_price not between", value1, value2, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountIsNull() {
            addCriterion("overlay_discount is null");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountIsNotNull() {
            addCriterion("overlay_discount is not null");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountEqualTo(Boolean value) {
            addCriterion("overlay_discount =", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountNotEqualTo(Boolean value) {
            addCriterion("overlay_discount <>", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountGreaterThan(Boolean value) {
            addCriterion("overlay_discount >", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountGreaterThanOrEqualTo(Boolean value) {
            addCriterion("overlay_discount >=", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountLessThan(Boolean value) {
            addCriterion("overlay_discount <", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountLessThanOrEqualTo(Boolean value) {
            addCriterion("overlay_discount <=", value, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountIn(List<Boolean> values) {
            addCriterion("overlay_discount in", values, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountNotIn(List<Boolean> values) {
            addCriterion("overlay_discount not in", values, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountBetween(Boolean value1, Boolean value2) {
            addCriterion("overlay_discount between", value1, value2, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andOverlayDiscountNotBetween(Boolean value1, Boolean value2) {
            addCriterion("overlay_discount not between", value1, value2, "overlayDiscount");
            return (Criteria) this;
        }

        public Criteria andUseScopeIsNull() {
            addCriterion("use_scope is null");
            return (Criteria) this;
        }

        public Criteria andUseScopeIsNotNull() {
            addCriterion("use_scope is not null");
            return (Criteria) this;
        }

        public Criteria andUseScopeEqualTo(String value) {
            addCriterion("use_scope =", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotEqualTo(String value) {
            addCriterion("use_scope <>", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeGreaterThan(String value) {
            addCriterion("use_scope >", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeGreaterThanOrEqualTo(String value) {
            addCriterion("use_scope >=", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeLessThan(String value) {
            addCriterion("use_scope <", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeLessThanOrEqualTo(String value) {
            addCriterion("use_scope <=", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeLike(String value) {
            addCriterion("use_scope like", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotLike(String value) {
            addCriterion("use_scope not like", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeIn(List<String> values) {
            addCriterion("use_scope in", values, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotIn(List<String> values) {
            addCriterion("use_scope not in", values, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeBetween(String value1, String value2) {
            addCriterion("use_scope between", value1, value2, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotBetween(String value1, String value2) {
            addCriterion("use_scope not between", value1, value2, "useScope");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateIsNull() {
            addCriterion("receive_expiration_date is null");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateIsNotNull() {
            addCriterion("receive_expiration_date is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateEqualTo(Integer value) {
            addCriterion("receive_expiration_date =", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateNotEqualTo(Integer value) {
            addCriterion("receive_expiration_date <>", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateGreaterThan(Integer value) {
            addCriterion("receive_expiration_date >", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateGreaterThanOrEqualTo(Integer value) {
            addCriterion("receive_expiration_date >=", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateLessThan(Integer value) {
            addCriterion("receive_expiration_date <", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateLessThanOrEqualTo(Integer value) {
            addCriterion("receive_expiration_date <=", value, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateIn(List<Integer> values) {
            addCriterion("receive_expiration_date in", values, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateNotIn(List<Integer> values) {
            addCriterion("receive_expiration_date not in", values, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateBetween(Integer value1, Integer value2) {
            addCriterion("receive_expiration_date between", value1, value2, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andReceiveExpirationDateNotBetween(Integer value1, Integer value2) {
            addCriterion("receive_expiration_date not between", value1, value2, "receiveExpirationDate");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNull() {
            addCriterion("start_time is null");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNotNull() {
            addCriterion("start_time is not null");
            return (Criteria) this;
        }

        public Criteria andStartTimeEqualTo(Date value) {
            addCriterion("start_time =", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotEqualTo(Date value) {
            addCriterion("start_time <>", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThan(Date value) {
            addCriterion("start_time >", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("start_time >=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThan(Date value) {
            addCriterion("start_time <", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThanOrEqualTo(Date value) {
            addCriterion("start_time <=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIn(List<Date> values) {
            addCriterion("start_time in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotIn(List<Date> values) {
            addCriterion("start_time not in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeBetween(Date value1, Date value2) {
            addCriterion("start_time between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotBetween(Date value1, Date value2) {
            addCriterion("start_time not between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNull() {
            addCriterion("end_time is null");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNotNull() {
            addCriterion("end_time is not null");
            return (Criteria) this;
        }

        public Criteria andEndTimeEqualTo(Date value) {
            addCriterion("end_time =", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotEqualTo(Date value) {
            addCriterion("end_time <>", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThan(Date value) {
            addCriterion("end_time >", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("end_time >=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThan(Date value) {
            addCriterion("end_time <", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("end_time <=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIn(List<Date> values) {
            addCriterion("end_time in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotIn(List<Date> values) {
            addCriterion("end_time not in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeBetween(Date value1, Date value2) {
            addCriterion("end_time between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("end_time not between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeIsNull() {
            addCriterion("reality_end_time is null");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeIsNotNull() {
            addCriterion("reality_end_time is not null");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeEqualTo(Date value) {
            addCriterion("reality_end_time =", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeNotEqualTo(Date value) {
            addCriterion("reality_end_time <>", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeGreaterThan(Date value) {
            addCriterion("reality_end_time >", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("reality_end_time >=", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeLessThan(Date value) {
            addCriterion("reality_end_time <", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("reality_end_time <=", value, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeIn(List<Date> values) {
            addCriterion("reality_end_time in", values, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeNotIn(List<Date> values) {
            addCriterion("reality_end_time not in", values, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeBetween(Date value1, Date value2) {
            addCriterion("reality_end_time between", value1, value2, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andRealityEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("reality_end_time not between", value1, value2, "realityEndTime");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeIsNull() {
            addCriterion("create_user_type is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeIsNotNull() {
            addCriterion("create_user_type is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeEqualTo(Integer value) {
            addCriterion("create_user_type =", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeNotEqualTo(Integer value) {
            addCriterion("create_user_type <>", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeGreaterThan(Integer value) {
            addCriterion("create_user_type >", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("create_user_type >=", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeLessThan(Integer value) {
            addCriterion("create_user_type <", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeLessThanOrEqualTo(Integer value) {
            addCriterion("create_user_type <=", value, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeIn(List<Integer> values) {
            addCriterion("create_user_type in", values, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeNotIn(List<Integer> values) {
            addCriterion("create_user_type not in", values, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeBetween(Integer value1, Integer value2) {
            addCriterion("create_user_type between", value1, value2, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("create_user_type not between", value1, value2, "createUserType");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIsNull() {
            addCriterion("create_user_name is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIsNotNull() {
            addCriterion("create_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameEqualTo(String value) {
            addCriterion("create_user_name =", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotEqualTo(String value) {
            addCriterion("create_user_name <>", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameGreaterThan(String value) {
            addCriterion("create_user_name >", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("create_user_name >=", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLessThan(String value) {
            addCriterion("create_user_name <", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLessThanOrEqualTo(String value) {
            addCriterion("create_user_name <=", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLike(String value) {
            addCriterion("create_user_name like", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotLike(String value) {
            addCriterion("create_user_name not like", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIn(List<String> values) {
            addCriterion("create_user_name in", values, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotIn(List<String> values) {
            addCriterion("create_user_name not in", values, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameBetween(String value1, String value2) {
            addCriterion("create_user_name between", value1, value2, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotBetween(String value1, String value2) {
            addCriterion("create_user_name not between", value1, value2, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoIsNull() {
            addCriterion("create_user_mer_no is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoIsNotNull() {
            addCriterion("create_user_mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoEqualTo(String value) {
            addCriterion("create_user_mer_no =", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoNotEqualTo(String value) {
            addCriterion("create_user_mer_no <>", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoGreaterThan(String value) {
            addCriterion("create_user_mer_no >", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("create_user_mer_no >=", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoLessThan(String value) {
            addCriterion("create_user_mer_no <", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoLessThanOrEqualTo(String value) {
            addCriterion("create_user_mer_no <=", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoLike(String value) {
            addCriterion("create_user_mer_no like", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoNotLike(String value) {
            addCriterion("create_user_mer_no not like", value, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoIn(List<String> values) {
            addCriterion("create_user_mer_no in", values, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoNotIn(List<String> values) {
            addCriterion("create_user_mer_no not in", values, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoBetween(String value1, String value2) {
            addCriterion("create_user_mer_no between", value1, value2, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andCreateUserMerNoNotBetween(String value1, String value2) {
            addCriterion("create_user_mer_no not between", value1, value2, "createUserMerNo");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}